#include "descriptor/descriptor.h"

#define NUM_NURBS_OBJ 13
#define OBJ_ARR { \
{"alce.dbe",     0, 0, 0}, \
{"naso.db",    0, 0, 0}, \
{"nuca.dbe",    0, 0, 0}, \
{"occhiodx.db",     0, 0, 0}, \
{"occhiosx.db", 0, 0, 0}, \
{"orecchiosx.db", 0, 0, 0}, \
{"orecchiodx.db", 0, 0, 0}, \
{"collo.db", 0, 0, 0}, \
{"corna.db",     0, 0, 0}, \
{"occhio_sx.db",   0, 0, 0}, \
{"occhio_dx.db",   0, 0, 0}, \
{"base.db",   0, 0, 0}, \
{"bocca.dbe",   0, 0, 0} \
}

#define NUM_NURBS_OBJ2 11
#define OBJ2_ARR { \
{"pavimento.db",     0, 0, 0}, \
{"soffitto.db",    0, 0, 0}, \
{"parete3.db",    0, 0, 0}, \
{"parete4.db",     0, 0, 0}, \
{"parete5.db", 0, 0, 0}, \
{"bicchiere.db", 0, 0, 0}, \
{"caraffa.db", 0, 0, 0}, \
{"tavolo.db", 0, 0, 0}, \
{"bottle.db",     0, 0, 0}, \
{"vino.db",   0, 0, 0}, \
{"tappo.db",   0, 0, 0} \
}

// fattore di scala per la mappatura dell' alce
#define SCALE 3

// struttura per gli oggetti obj
typedef struct {
  char   name[50];
  double r, g, b;
} Obj_t;

static Obj_t obj_desc[NUM_NURBS_OBJ] = OBJ_ARR;
static Obj_t obj2_desc[NUM_NURBS_OBJ2] = OBJ2_ARR;

int main(void)
{

	int nogg;
	ITEM	oggetto[NUM_NURBS_OBJ],oggetto2[NUM_NURBS_OBJ2], brown, black, white, glass, bottle_glass, ceramic, vino, lista;

	set_background(0.5,0.5,0.5,TRUE);
	set_ambient_light(1,1,1,0.7);
	create_point_light(0,-17,5,1,1,1,2.3,100,"light1");

	/*** ATTRIBUTE brown ***/
	brown = create_attribute("brown");
	set_color(brown,0.55,0.45,0.07,0.2,0.5);

	black = create_attribute("black");
	set_color(black,0.0,0.0,0.0,0.2,0.9);
	set_reflectivity(black,0.22,3);

	white = create_attribute("white");
	set_color(white,0.6,0.6,0.6,0.2,0.6);

	glass = create_attribute("glass");
	set_color(glass,0.68,0.86,1,0.5,0.5);
	set_reflectivity(glass,0.24,2);
	set_transparency(glass,0.87,0.68,1,1.2);

	bottle_glass = create_attribute("bottle_glass");
	set_color(bottle_glass,0.4,0.8,0.3,0.5,0.5);
	set_reflectivity(bottle_glass,0.24,2);
	set_transparency(bottle_glass,0.87,0.68,1,1.2);

	vino = create_attribute("vino");
	set_color(vino,0.5,0.15,0.15,0.5,0.5);
	set_reflectivity(vino,0.24,2);
	set_transparency(vino,0.32,0.23,3,5);

	ceramic = create_attribute("ceramic");
	set_color(ceramic,0.89,0.76,0.65,0.1,0.8);
	set_reflectivity(ceramic,0.2,128);

	for(nogg = 0; nogg < NUM_NURBS_OBJ; nogg++)
	{
		oggetto[nogg] = read_nurbs(obj_desc[nogg].name);
		if (nogg==8) // cona dell' alce
			set_attribute(oggetto[nogg], white);

		else if (nogg==9 || nogg==10 || nogg == 1) // occhi e naso
			set_attribute(oggetto[nogg], black);

		else if (nogg==11) // base
		{
			set_attribute(oggetto[nogg], brown);
			set_projection_texture(oggetto[nogg],brown,"textures/wood.hr",1,TRUE,0.2,0.5);
		}

		else
		{
			set_attribute(oggetto[nogg], brown);
			set_scale(oggetto[nogg],SCALE,SCALE,SCALE);
			set_projection_texture(oggetto[nogg],brown,"textures/fur.hr",2,TRUE,0.2,0.5);
			set_scale(oggetto[nogg],1.0/SCALE,1.0/SCALE,1.0/SCALE);
		}
	}

	for(nogg = 0; nogg < NUM_NURBS_OBJ2; nogg++)
	{
		oggetto2[nogg] = read_nurbs(obj2_desc[nogg].name);

		if (nogg==0) // pavimento
		{
			set_attribute(oggetto2[nogg],white);
			set_scale(oggetto2[nogg],1.0/3,1.0/3,1.0/3);
			set_projection_texture(oggetto2[nogg],white,"textures/pavimento.hr",2,TRUE,0.3,0.5);
			set_scale(oggetto2[nogg],3,3,3);
		}
		else if (nogg==2) // parete
		{
			set_attribute(oggetto2[nogg],white);
			set_scale(oggetto2[nogg],1.0/4,1.0/4,1.0/4);
			set_projection_texture(oggetto2[nogg],white,"textures/antique_white.hr",1,TRUE,0.25,0.4);
			set_scale(oggetto2[nogg],4,4,4);
		}
		else if (nogg==5) // bicchiere
		{
			set_attribute(oggetto2[nogg], glass);
		}
		else if (nogg==7) // tavolo
		{
			set_attribute(oggetto2[nogg], brown);
			set_scale(oggetto2[nogg],1.0/2,1.0/2,1.0/2);
			set_projection_texture(oggetto2[nogg],brown,"textures/cordova_stone.hr",2,TRUE,0.2,0.4);
			set_scale(oggetto2[nogg],2,2,2);
		}
		else if (nogg==8) // bottiglia
		{
			set_attribute(oggetto2[nogg], bottle_glass);
		}
		else if (nogg==9) // vino
		{
			set_attribute(oggetto2[nogg], vino);
		}
		else if (nogg==10) // tappo
		{
			set_attribute(oggetto2[nogg], brown);
		}
		else if (nogg==6) // caraffa
		{
			set_attribute(oggetto2[nogg], ceramic);
		}
		else
			set_attribute(oggetto2[nogg], white);
	}

	lista = create_list(oggetto[0], "alce");

	for (nogg = 1; nogg < NUM_NURBS_OBJ; nogg++)
		lista = insert_in_list(lista, oggetto[nogg]);

	for (nogg = 0; nogg < NUM_NURBS_OBJ2; nogg++)
		lista = insert_in_list(lista, oggetto2[nogg]);


	save_scene("alce.md","scene",lista);
	return(0);
}


